package japflash;

import java.awt.*;
import java.awt.event.*;

/**
 * Title:        JapFlash
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      LXWorks
 * @author insaneLX
 * @version 1.0
 */

public class FontsDialog extends Dialog implements WindowListener {
  Frame owner;
  Options o;
  int result;
  final static int OK = 1;
  final static int CANCEL = 2;
  final static int CLOSE = 3;
  Font kFont;
  Font tFont;


  Panel cardPreviewPanel = new Panel();
  Panel panel6 = new Panel();
  Panel panel3 = new Panel();
  Panel panel2 = new Panel();

  GridLayout gridLayout1 = new GridLayout();
  GridLayout gridLayout3 = new GridLayout();
  GridLayout gridLayout2 = new GridLayout();
  BorderLayout borderLayout1 = new BorderLayout();

  Label kanjiLabel = new Label();
  Label textLabel = new Label();

  Button oKbutton = new Button();
  Button cancelButton = new Button();
  Button textPlusButton = new Button();
  Button kanjiPlusButton = new Button();
  Button textMinusButton = new Button();
  Button kanjiMinusButton = new Button();
  FlowLayout flowLayout1 = new FlowLayout();
  Checkbox loadFileAtStartupCheckbox = new Checkbox();

  public FontsDialog(Frame ow) {
    super(ow,"Font Size Setup");
    owner = ow;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void setOptions(Options options) {
    o = options;
  }

  private void jbInit() throws Exception {
    super.setSize(220,170);
    super.setModal(true);
    gridLayout2.setRows(2);
    gridLayout2.setColumns(3);
    addWindowListener(this);

    this.setBackground(Color.lightGray);

    oKbutton.setLabel("OK");
    oKbutton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        oKbutton_actionPerformed(e);
      }
    });
    cancelButton.setLabel("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cancelButton_actionPerformed(e);
      }
    });
    panel3.setLayout(gridLayout1);
    gridLayout1.setRows(2);
    gridLayout1.setColumns(2);
    panel6.setLayout(borderLayout1);
    textPlusButton.setLabel("Text +");
    textPlusButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        textPlusButton_actionPerformed(e);
      }
    });
    kanjiLabel.setAlignment(1);
    kanjiLabel.setText("Kanji");
    cardPreviewPanel.setLayout(gridLayout3);
    gridLayout3.setColumns(2);
    textLabel.setAlignment(1);
    textLabel.setText("Text");
    kanjiPlusButton.setLabel("Kanji +");
    kanjiPlusButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        kanjiPlusButton_actionPerformed(e);
      }
    });
    textMinusButton.setLabel("Text -");
    textMinusButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        textMinusButton_actionPerformed(e);
      }
    });
    kanjiMinusButton.setLabel("Kanji -");
    kanjiMinusButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        kanjiMinusButton_actionPerformed(e);
      }
    });

    panel2.setLayout(flowLayout1);
    loadFileAtStartupCheckbox.setLabel("load last file at startup");
    loadFileAtStartupCheckbox.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        loadFileAtStartupCheckbox_itemStateChanged(e);
      }
    });
    panel2.add(oKbutton, null);
    panel2.add(cancelButton, null);
    this.add(loadFileAtStartupCheckbox, BorderLayout.NORTH);
    this.add(panel6,  BorderLayout.CENTER);
    panel6.add(panel3, BorderLayout.NORTH);
    panel6.add(cardPreviewPanel,  BorderLayout.CENTER);
    this.add(panel2, BorderLayout.SOUTH);
    cardPreviewPanel.add(kanjiLabel, null);
    cardPreviewPanel.add(textLabel, null);
    panel3.add(kanjiPlusButton, null);
    panel3.add(textPlusButton, null);
    panel3.add(kanjiMinusButton, null);
    panel3.add(textMinusButton, null);
    kanjiLabel.setText("\u6f22\u5b57");
  }

  void oKbutton_actionPerformed(ActionEvent e) {
    close(OK);
  }

  void cancelButton_actionPerformed(ActionEvent e) {
    close(CANCEL);
  }

  void kanjiMinusButton_actionPerformed(ActionEvent e) {
    int size = kFont.getSize()-2;
    if (size < o.minFontSize) size = o.minFontSize;
    kFont = new Font(kFont.getName(),
                           kFont.getStyle(),size);
    kanjiLabel.setFont(kFont);
  }

  void kanjiPlusButton_actionPerformed(ActionEvent e) {
    int size = kFont.getSize()+2;
    if (size > o.maxFontSize) size = o.maxFontSize;
    kFont = new Font(kFont.getName(),
                           kFont.getStyle(),size);
    kanjiLabel.setFont(kFont);
  }



  void close(int r) {
    if (r == OK) {o.kanjiFont = kFont;o.textFont = tFont;}
    result = r;
    setVisible(false);
  }

  public void windowClosing(WindowEvent e) {close(CANCEL);}
  public void windowClosed(WindowEvent e) {}
  public void windowDeactivated(WindowEvent e) {}
  public void windowActivated(WindowEvent e) {
    kFont = new Font(o.kanjiFont.getName(),o.kanjiFont.getStyle(),
                     o.kanjiFont.getSize());
    tFont = new Font(o.textFont.getName(),o.textFont.getStyle(),
                     o.textFont.getSize());
    kanjiLabel.setFont(kFont);
    textLabel.setFont(tFont);
    loadFileAtStartupCheckbox.setState(o.loadLastFileAtStartup);
    setLocation(owner.getLocationOnScreen().x+6,owner.getLocationOnScreen().y+40);

  }

  public void windowDeiconified(WindowEvent e) {}
  public void windowIconified(WindowEvent e) {}
  public void windowOpened(WindowEvent e) {}
  void textPlusButton_actionPerformed(ActionEvent e) {
    int size = tFont.getSize()+2;
    if (size > o.maxFontSize) size = o.maxFontSize;
    tFont = new Font(tFont.getName(),
                           tFont.getStyle(),size);
    textLabel.setFont(tFont);

  }
  void textMinusButton_actionPerformed(ActionEvent e) {
    int size = tFont.getSize()-2;
    if (size < o.minFontSize) size = o.minFontSize;
    tFont = new Font(tFont.getName(),
                           tFont.getStyle(),size);
    textLabel.setFont(tFont);
  }

  void loadFileAtStartupCheckbox_itemStateChanged(ItemEvent e) {
    o.loadLastFileAtStartup = loadFileAtStartupCheckbox.getState();
  }
}