package japsupport;
/**
 * Title:        JapFlash
 * Copyright:
 * Parts of this program (Japanese Bitmap Font support) are taken
 * from KanjiFlash by Marshall Ramsey
 * This program is the copyright of Alexander Bergner, however, you have
 * permission to use the source code as long as the programs you create
 * will be made available without charge and you include the programs'
 * source code and credit is given to me and Marshall Ramsey for providing
 * the code you use.
 * You may distribute this program as long as all the files are included
 * in the distribution and it is provided free of charge or for a small
 * materials fee.
 * @author insaneLX
 * @version 1.0
 */

import java.awt.*;

public class TextCanvas extends Canvas {
  public static final int CENTER=0;
  public static final int LEFT=1;
  public static final int RIGHT=1;
  public static final int DEFAULT_MAXSIZE = 120;
  protected int justify;
  protected String text;
  protected boolean showing;

  public TextCanvas() {
    text = new String("");
    this.justify = LEFT;
    showing = true;
  }

  public TextCanvas(int justify) {
    text = new String("");
    this.justify = justify;
    showing = true;
  }

  public void setText(String text) { this.text = text; repaint(); }

  public String getText() { return text; }

  public void setVisible(boolean visible) {
    showing = visible; repaint();
  }

  public void setMaxSize(int maxSize) {  } // default: do nothing

  // draw a border around drawing area
  public void paint(Graphics g) {
    Dimension d = getSize();

    //draw border
    g.setColor(Color.gray);
    g.drawLine(0, 0, d.width-1, 0);
    g.drawLine(0, 1, 0, d.height-1);
    g.setColor(Color.black);
    g.drawLine(1, 1, d.width-2, 1);
    g.drawLine(1, 2, 1, d.height-2);
    g.setColor(Color.lightGray);
    g.drawLine(d.width-2, 1, d.width-2, d.height-2);
    g.drawLine(1, d.height-2, d.width-2, d.height-2);
    g.setColor(Color.white);
    g.drawLine(d.width-1, 0, d.width-1, d.height-1);
    g.drawLine(0, d.height-1, d.width-1, d.height-1);
  }
}


