package tools;

import java.awt.Color;
import java.awt.Label;

/**
 * Title:        JapFlash
 * Copyright:
 * Parts of this program (Japanese Bitmap Font support) are taken
 * from KanjiFlash by Marshall Ramsey
 * This program is the copyright of Alexander Bergner, however, you have
 * permission to use the source code as long as the programs you create
 * will be made available without charge and you include the programs'
 * source code and credit is given to me and Marshall Ramsey for providing
 * the code you use.
 * You may distribute this program as long as all the files are included
 * in the distribution and it is provided free of charge or for a small
 * materials fee.
 * @author insaneLX
 * @version 1.0
 */


public class LXToolBox {

  static final boolean debug = false;
  static Label messageLabel;

  public LXToolBox() {
  }

  public static Color blendColor(Color start, Color end,float alpha) {
    float[] sHSB = new float[3];
    float[] eHSB = new float[3];

    Color.RGBtoHSB(start.getRed(),start.getGreen(),start.getBlue(),sHSB);
    Color.RGBtoHSB(end.getRed(),end.getGreen(),end.getBlue(),eHSB);
    return Color.getHSBColor(sHSB[0]*alpha+eHSB[0]*(1f-alpha),
                             sHSB[1]*alpha+eHSB[1]*(1f-alpha),
                             sHSB[2]*alpha+eHSB[2]*(1f-alpha));
  }

  public static void setMessageLabel(Label mL) {
    messageLabel = mL;
  }

  public static void message(String message) {
    if (messageLabel != null) messageLabel.setText(message);
    System.out.println(message);
  }

  public static void debugMessage(String message) {
    if (debug) {
    System.out.println(message);
    if (messageLabel != null) messageLabel.setText(message);
    }
  }
}